#define BIT7 0x80
#define BIT6 0x40
#define BIT5 0x20
#define BIT4 0x10
#define BIT3 0x08
#define BIT2 0x04
#define BIT1 0x02
#define BIT0 0x01

#define HIGH 1
#define LOW 0

#define TRUE 1
#define FALSE 0

#define SET 1
#define CLEARED 0

#define LOWBYTE(v)   ((unsigned char) (v))
#define HIGHBYTE(v)  ((unsigned char) (((unsigned int) (v)) >> 8))

//SFRs
#define TIMER2_PAGE 0
#define ADC0_PAGE 0x30
#define PCA0_PAGE 0
#define UART0_PAGE 0x20

//ASCII
#define ASCII_CR 13
#define ASCII_NULL 0

//ADC
#define SCAN_SIZE_BYTES_ACC 120 //60 conversions (20 per channel), which is 120 bytes of ADC data

//function prototypes
void Delay_us(unsigned int DelayCount);
void Delay_10ms(unsigned int DelayCount);
void Delay_seconds(unsigned int DelayCount);
void FullSpeed_Forward(void);
void FullSpeed_Reverse(void);
void FullSpeed_TurnRight(void);
void FullSpeed_TurnLeft(void);
void StopMotors(void);
void ConfigureADC_AutoScan(void);
void Transfer_ADCBuffer(unsigned int num_bytes);

//global variables
extern unsigned int AutoScan_StartingAddress;
extern unsigned char xdata AutoScan_Memory[3000];
extern bit SEND_ADC_DATA;
extern bit LAST_SCAN;

//port pins
sbit C2ADAPTER_LEDGRN = P2^1;
sbit C2ADAPTER_LEDRED = P2^0;
sbit MOT_R_PWM = P0^6;
sbit MOT_L_PWM = P0^7;
sbit MOT_R_nEN = P1^0;
sbit MOT_L_nEN = P1^1;
sbit MOT_R_DIR = P1^2;
sbit MOT_L_DIR = P1^3;
sbit ACC_ST = P2^6;
