//=========================================================
// src/Interrupts.c: generated by Hardware Configurator
//
// This file will be regenerated when saving a document.
// leave the sections inside the "$[...]" comment tags alone
// or they will be overwritten!!
//=========================================================

// USER INCLUDES
#include <SI_EFM8LB1_Register_Enums.h>
#include "Project_DefsVarsFuncs.h"

//-----------------------------------------------------------------------------
// ADC0EOC_ISR
//-----------------------------------------------------------------------------
//
// ADC0EOC ISR Content goes here. Remember to clear flag bits:
// ADC0CN0::ADINT (Conversion Complete Interrupt Flag)
//
//-----------------------------------------------------------------------------
SI_INTERRUPT (ADC0EOC_ISR, ADC0EOC_IRQn)
{
	ADC0CN0_ADINT = 0;	//clear interrupt flag

	if(LAST_SCAN == TRUE)
	{
		LAST_SCAN = FALSE;
		SEND_ADC_DATA = TRUE;
	}

	/*If AutoScan_StartingAddress is 2280, the next
	 * scan will fill memory locations 2280 to 2399,
	 * which means that it is the last scan.*/
	else if(AutoScan_StartingAddress == 2280)
	{
		ADC0CN0_ADBUSY = 1;	//start the last scan

		LAST_SCAN = TRUE;

		ADC0ASCF &= ~BIT7;	//prevent additional scans after the next one
	}

	/*If AutoScan_StartingAddress is less than 2280,
	 * we have not reached the last scan, so we start
	 * the next scan and load the starting address for
	 * the following scan.*/
	else if(AutoScan_StartingAddress < 2280)
	{
		ADC0CN0_ADBUSY = 1;	//start the next scan

		//now we need to load the address for the following scan
		AutoScan_StartingAddress = AutoScan_StartingAddress + SCAN_SIZE_BYTES_ACC;
		ADC0ASAH = HIGHBYTE(0x0FFF & AutoScan_StartingAddress);
		ADC0ASAL = LOWBYTE(0xFFFE & AutoScan_StartingAddress);
	}
}
