//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include <SI_EFM8LB1_Register_Enums.h>                  // SFR declarations
#include "InitDevice.h"
#include "Project_DefsVarsFuncs.h"


//-----------------------------------------------------------------------------
// main() Routine
// ----------------------------------------------------------------------------
int main(void)
{
	int n=0;

	//call hardware initialization routine
	enter_DefaultMode_from_RESET();

	StopMotors();	//ensure that the motors are disabled

	//clear the entire ADC buffer
	for(n=0; n<3000; n++)
	{
		AutoScan_Memory[n] = 0;
	}

	ConfigureADC_AutoScan();

	ACC_ST = 0;	//self-test is not active

	//start the first ADC autoscan
	SFRPAGE = ADC0_PAGE;
	ADC0CN0_ADBUSY = 1;

	while(1)
	{
		if(SEND_ADC_DATA == TRUE)
		{
			SEND_ADC_DATA = FALSE;
			Transfer_ADCBuffer(2400);
		}
	}
}
