#include <SI_EFM8LB1_Register_Enums.h>                  // SFR declarations
#include "Project_DefsVarsFuncs.h"

void Delay_us(unsigned int DelayCount)
{
	unsigned char SFRPage_save = SFRPAGE;
	SFRPAGE = TIMER2_PAGE;

	//first, compensate for the time required to execute all the instructions related to the delay function
	//this compensation was originally based on empirical measurements
	if(DelayCount < 3)
		DelayCount = 3;
	DelayCount = DelayCount - 2;

	TMR2CN0_TR2 = 0;		//make sure Timer2 is stopped
	TMR2CN0_TF2H = 0;		//clear overflow flag
	TMR2 = 0xFFFF - DelayCount;	//Timer2 runs at 1.021 MHz = ~1 MHz, so counts to overflow ~= (delay in microseconds)
	TMR2CN0_TR2 = 1;		//start Timer2
	while(!TMR2CN0_TF2H);	//wait until overflow flag is set
	TMR2CN0_TF2H = 0;	//clear overflow flag
	TMR2CN0_TR2 = 0;		//stop Timer2

	SFRPAGE = SFRPage_save;
}

void Delay_10ms(unsigned int DelayCount)
{
	unsigned int n;

	for(n=0; n<DelayCount; n++)
	{
		Delay_us(10000);
	}
}

void Delay_seconds(unsigned int DelayCount)
{
	unsigned int n;

	for(n=0; n<DelayCount; n++)
	{
		Delay_10ms(100);
	}
}

bit Is_In_Range(int input, int LowerBound, int UpperBound)
{
	if(input >= LowerBound && input <= UpperBound)
		return TRUE;

	else
		return FALSE;
}
